$dir=shift; opendir(D1,$dir); $fs=shift;
while($f=readdir(D1)) {

#$f=shift;

if($f !~ /\.flankunaligned/) {next;}

$f=$dir.$f; $st=$f; $st =~ s/\.seq/\.startend/g;
open(IN,$st); $l=<IN>; @s=split(/\s+/,$l); $start=$s[0]; $end=$s[1]; close IN;
#print "rnaseq=$rnaseq\n";

$rna=$f; @u=split(/\//,$f); @s=split(/\./,$u[scalar(@u)-1]); $rna=$s[0];

print "Doing file $u[scalar(@u)-1]\nBaliscores:\n";

@open=(1);@ext=(1);
foreach my $op (@open){
 foreach my $ex (@ext){

#first build model
  open(OUT, ">tempalign.$fs");  open(IN, $f); $n1=<IN>; $s1=<IN>; $n2=<IN>; $s2=<IN>;
  if(length($s1) < length($s2)) { $qname=$n1; $qseq=$s1; } 
  else { $qname=$n2; $qseq=$s2; }
  chomp $qname; chomp $qseq; $qlen=length($qseq); printf OUT "%s\n%s\n", $qname, $qseq; close OUT;
  system "perl fasta_to_phylip.pl tempalign.$fs > crapout.$fs";

  system "./hmmbuild --nucleic --informat=PHYLIP -f -F crap.hmm crapout.$fs >& /dev/null";
 
  $f2=$f; $f2=~s/\.flankunaligned/\.seq/g;
#  print "perl hmmer2.pl $f2 $fs\n";
  $se_ = `/usr/bin/time -f %UX%S -o hmmertime perl hmmer2.pl $f2 $fs`; chomp $se_;
  $time1 = `cat hmmertime`; chomp $time1; @s=split(/X/,$time1); $time1=$s[0]+$s[1];
  @s=split(/\s+/,$se_); $es=$s[0]; $ee=$s[1]; $qlen_=$s[2]; $se_="$es $ee";
  $se=$f2; $se=~s/\.seq/.startend/g; 
  open(IN,$se); $l=<IN>; @s=split(/\s+/,$l); $ts=$s[0]; $te=$s[1];
#  print "perl get_score.pl $ts $te $se_\n";
  $score=`perl get_score.pl $ts $te $se_`; chomp $score;
  @s=split(/\s+/,$score); $fp=100*$s[0]; $fn=100*$s[1];
#  print "qlen=$qlen, hmmerqlen=$qlen_\n";
  if($qlen != $qlen_){ print "ERROR: lengths not equal\n"; }
  else { print "HMMER:  FP=$fp  FN=$fn  Time=$time1\n";}
 }
}

print "---------------------\n";

}
