$dir=shift; opendir(D1,$dir); $fs=shift;
while($f=readdir(D1)) {

#$f=shift;

if($f !~ /\.gengen/ && $f !~ /\.seq/) {next;}
if($f =~ /\.seq/){ next; $f=$dir.$f; $unal=$f; $unal=~s/\.seq/\.flankunaligned/g; }
if($f =~ /\.gengen4/){ next; $f=$dir.$f; $unal=$f; }
if($f !~ /\.gengen4/ && $f =~ /\.gengen2/){ $f=$dir.$f; $unal=$f; }

if($f =~ /\.seq/){ 
  open(IN, $unal); $n1=<IN>; $s1=<IN>; $n2=<IN>; $s2=<IN>;
  if(length($s1) < length($s2)) { $qseq=$s1; } else { $qseq=$s2; } 
  chomp $qseq; $qlen=length($qseq); 
}
if($f =~ /\.gengen2/){
  open(IN, $unal); $n1=<IN>; $s1=<IN>; $n2=<IN>; $s2=<IN>;
  $qname=$n1; $qseq=$s1;
  chomp $qseq; $qlen=length($qseq); 
}

$rna=$f; @u=split(/\//,$f); @s=split(/\./,$u[scalar(@u)-1]); $rna=$s[0];
print "Doing file $u[scalar(@u)-1]\nBaliscores:\n"; 

@open=(8, 10, 12, 14, 16, 18, 20);
@ext=(1, 1.5, 2, 2.5, 3);
#@open=(14); @ext=(2);
foreach my $op (@open){
 foreach my $ex (@ext){

#q^
#  $se_ = `perl do_ssearch.pl $unal $op $ex $fs`;
#  print "/usr/bin/time -f %UX%S -o time1.$fs perl do_ssearch2.pl $unal $op $ex $fs\n";
  if($f =~ /\.seq/){ $se_ = `/usr/bin/time -f %UX%S -o time1.$fs perl do_ssearch2.pl $unal $op $ex $fs`;}
  elsif($f =~ /\.gengen2/){ $se_ = `/usr/bin/time -f %UX%S -o time1.$fs perl do_ssearch2_gengen.pl $unal $op $ex $fs`;}
  else { print "error at $f!\n"; exit; }
#  print $se_;
  $time1 = `cat time1.$fs`; chomp $time1; @s=split(/X/,$time1); $time1=$s[0]+$s[1];

  @s=split(/\s+/,$se_); $es=$s[0]; $ee=$s[1]; $qlen_=$s[2];

  if ($f =~ /\.seq/) { $se=$f; $se=~s/\.seq/.startend/g; }
  elsif ($f =~ /\.gengen2/) { $se=$f; $se=~s/\.gengen2/.startend/g; $se=~s/flank/only/g; $se=~s/training3/divergent/g; }

  open(IN,$se); $l=<IN>; @s=split(/\s+/,$l); $ts=$s[0]; $te=$s[1];
#  print "perl get_score.pl $ts $te $se_\n";
  $score=`perl get_score.pl $ts $te $se_`; chomp $score; 
  @s=split(/\s+/,$score); $fp=100*$s[0]; $fn=100*$s[1]; 
#  $score=`perl get_score2.pl $ts $te $se_`; chomp $score; 
#  @s=split(/\s+/,$score); $tp=$s[0]; $tp2=$s[1]; $tp3=$s[2]; $tp4=$s[3];

  $ssearchSP=`perl get_spscore_ssearch.pl ssearch_out.$fs`; $zscore=`perl get_zscore.pl ssearch_out.$fs`; $escore=`perl get_Evalue.pl ssearch_out.$fs`;
  $len = `perl get_startend3.pl ssearch_out.$fs.fasta`; 
  if($len <= 0) { print "ERROR: length <=0\n"; next; }
  $ssearchSP/=$len; $zscore/=$len; $escore/=$len;
#  print "qlen=$qlen, qlen_=$qlen_\n";
  if($qlen - $qlen_  > 0) { print "ERROR!\n"; }
  else {print "SSEARCH($op,$ex):  FP=$fp  FN=$fn"; printf "  SP=%.2f  Zscore=%.2f  Evalue=%e  Time=%.2f\n", $ssearchSP,$zscore,$escore,$time1;}
#   print "SSEARCH($op,$ex):  FP=$fp  FN=$fn"; printf "  SP=%.2f  Zscore=%.2f  Evalue=%e  Time=%.2f\n", $ssearchSP,$zscore,$escore,$time1;
#  print "SSEARCH($op,$ex):  TP=$tp  TP2=$tp2  TPRAW=$tp3  SE=$tp4"; printf "  SP=%.2f  Zscore=%.2f  Evalue=%e  Time=%.2f\n", $ssearchSP,$zscore,$escore,$time1;

#  `/bin/rm -f ssearch_out.$fs.fasta ssearch_out.$fs`;
#^if 0;
q^
  system "perl do_ssearch2.pl $unal $op $ex $fs";
  $al=$unal; $al=~s/unaligned/aligned/g;
  $out = `./qscore -ref $al -test ssearch_out.$fs.fasta`;
  @tmp=split(/\;/,$out); foreach my $x (@tmp){ if($x=~/Q\=/){@x=split(/\=/,$x);$sp=$x[1];} if($x=~/TC\=/){@x=split(/\=/,$x);$tc=$x[1];} } chomp $tc;
  print "SSEARCH($op,$ex):  SP=$sp  TC=$tc\n";
^if 0;
 }
}

print "---------------------\n";

}

