opendir(DIR,"RNA-genome-flank2-divergent");
$i=0;
while($f=readdir(DIR)){
  if($f=~/gengen5/){
    $f=~s/\.gengen5//g;
    $names[$i]=$f;
    $i++;
  }
}
closedir DIR;
$total=$i;

print "total=$total\n";

srand;
for(my $i=0; $i<$total;$i++){
  @s=split(/\./,$names[$i]);
  $rna=$s[0];
  $ind=int(rand($total));
  while($names[$ind] =~ /$rna/){
    $ind=int(rand($total));
  }

  print "exchanging $names[$i] and $names[$ind]\n";

  open(IN,"RNA-genome-flank2-divergent/$names[$i].gengen5");
  $n0=<IN>; $s0=<IN>; $n1=<IN>; $s1=<IN>; close IN;
  if(length($s0)>length($s1)){$q=$s1; $qn=$n1;}
  else {$q=$s0; $qn=$n0;}
  
  open(IN,"RNA-genome-flank2-divergent/$names[$ind].gengen5");
  $n0=<IN>; $s0=<IN>; $n1=<IN>; $s1=<IN>; close IN;
  if(length($s0)<length($s1)){$g=$s1; $gn=$n1;}
  else {$g=$s0; $gn=$n0;}
  
  open(OUT,">RNA-genome-FP4/$names[$i].gengen5");
  printf OUT "%s%s%s%s", $qn, $q, $gn, $g; close OUT;
}

